#!/usr/bin/perl
#
# Copyright (c) 2004 Atheros Communications, Inc.
#
# replace_meta -b <ap_board> -s <SOC_num> -f <FLASH> -c <clk_mhz> -e <enet>
#    -i <flash_infer> -w <flash_width> -a <16as8> -r <romsize> -m <ramsize>
#
use Getopt::Std;

getopts('b:s:f:c:e:i:w:a:r:m:');

if( $opt_a == "1" ) {
    $flash_16as8="#define CYGNUM_FLASH_16AS8      1";
}
else {
    $flash_16as8="";
}

$flash_infer="";
if( $opt_i == "1" ) {
    $flash_infer="cdl_option CYGHWR_DEVS_FLASH_AMD_AM29LV160 {   inferred_value 1};";
}

while ($line = <STDIN>) {
    $line =~ s/<<AP>>/$opt_b/ig;
    $line =~ s/<<SOC>>/$opt_s/ig;
    $line =~ s/<<FLASH>>/$opt_f/ig;
    $line =~ s/<<FLASH_BUS_WIDTH>>/$opt_w/ig;
    $line =~ s/<<FLASH_INFER>>/$flash_infer/ig;
    $line =~ s/<<CLKMHZ>>/$opt_c/ig;
    $line =~ s/<<ENETMANU>>/$opt_e/ig;
    $line =~ s/<<16AS8>>/$flash_16as8/ig;
    $line =~ s/<<ROMSIZE>>/$opt_r/ig;
    $line =~ s/<<RAMSIZE>>/$opt_m/ig;
    print "$line";
}

